Mute a call

This code snippet mutes / unmutes a call.

Example

Replace the following variables in the example code:

KeyDescription
VOICE_CALL_ID

The UUID of the call leg.

Prerequisites

Execute the following command at your terminal prompt to create the JWT for authentication:

export JWT=$(nexmo jwt:generate $PATH_TO_PRIVATE_KEY application_id=$NEXMO_APPLICATION_ID)

Write the code

Add the following to mute-a-call.sh:

curl -X PUT https://api.nexmo.com/v1/calls/$VOICE_CALL_ID \
  -H "Authorization: Bearer $JWT"\
  -H "Content-Type: application/json"\
  -d '{"action": "mute"}'

sleep 5s

curl -X PUT https://api.nexmo.com/v1/calls/$VOICE_CALL_ID \
  -H "Authorization: Bearer $JWT"\
  -H "Content-Type: application/json"\
  -d '{"action": "unmute"}'

View full source

Run your code

Save this file to your machine and run it:

bash mute-a-call.sh

Prerequisites

npm install @vonage/server-sdk

Create a file named mute-a-call.js and add the following code:

const { Vonage } = require('@vonage/server-sdk');

const vonage = new Vonage({
  applicationId: VONAGE_APPLICATION_ID,
  privateKey: VONAGE_PRIVATE_KEY,
});

View full source

Write the code

Add the following to mute-a-call.js:

vonage.voice.muteCall(VOICE_CALL_ID)
  .then(() => console.log('Call Muted'))
  .catch((error) => console.error(error));

const unmute = () => {
  vonage.voice.unmuteCall(VOICE_CALL_ID)
    .then(() => console.log('Unmuted Call'))
    .catch((error) => console.error(error));
};

setTimeout(unmute, 5000); // delay 5 seconds

View full source

Run your code

Save this file to your machine and run it:

node mute-a-call.js

Prerequisites

Add the following to build.gradle:

implementation 'com.vonage:server-sdk-kotlin:2.1.1'

Create a file named MuteCall and add the following code to the main method:

val client = Vonage {
    applicationId(VONAGE_APPLICATION_ID)
    privateKeyPath(VONAGE_PRIVATE_KEY_PATH)
}

View full source

Write the code

Add the following to the main method of the MuteCall file:

val call = client.voice.call(VOICE_CALL_ID)
call.mute()
Thread.sleep(3000)
call.unmute()

View full source

Run your code

We can use the application plugin for Gradle to simplify the running of our application. Update your build.gradle with the following:

apply plugin: 'application'
mainClassName = project.hasProperty('main') ? project.getProperty('main') : ''

Run the following gradle command to execute your application, replacing com.vonage.quickstart.kt.voice with the package containing MuteCall:

gradle run -Pmain=com.vonage.quickstart.kt.voice.MuteCall

Prerequisites

Add the following to build.gradle:

implementation 'com.vonage:server-sdk:9.3.1'

Create a file named MuteCall and add the following code to the main method:

VonageClient client = VonageClient.builder()
        .applicationId(VONAGE_APPLICATION_ID)
        .privateKeyPath(VONAGE_PRIVATE_KEY_PATH)
        .build();

View full source

Write the code

Add the following to the main method of the MuteCall file:

client.getVoiceClient().muteCall(VOICE_CALL_ID);
Thread.sleep(3000);
client.getVoiceClient().unmuteCall(VOICE_CALL_ID);

View full source

Run your code

We can use the application plugin for Gradle to simplify the running of our application. Update your build.gradle with the following:

apply plugin: 'application'
mainClassName = project.hasProperty('main') ? project.getProperty('main') : ''

Run the following gradle command to execute your application, replacing com.vonage.quickstart.voice with the package containing MuteCall:

gradle run -Pmain=com.vonage.quickstart.voice.MuteCall

Prerequisites

Install-Package Vonage

Write the code

Add the following to MuteCall.cs:

var credentials = Credentials.FromAppIdAndPrivateKeyPath(VONAGE_APPLICATION_ID, VONAGE_PRIVATE_KEY_PATH);
var client = new VonageClient(credentials);

var command = new CallEditCommand() { Action = CallEditCommand.ActionType.mute };
var response = await client.VoiceClient.UpdateCallAsync(VOICE_CALL_ID, command);

Console.WriteLine($"Mute Call Command succeeded: {response}");

Thread.Sleep(5000);

command = new CallEditCommand() { Action = CallEditCommand.ActionType.unmute };

response = await client.VoiceClient.UpdateCallAsync(VOICE_CALL_ID, command);

View full source

Prerequisites

composer require vonage/client

Write the code

Add the following to index.php:

require_once __DIR__ . '/../../vendor/autoload.php';

$keypair = new \Vonage\Client\Credentials\Keypair(file_get_contents(VONAGE_APPLICATION_PRIVATE_KEY_PATH), VONAGE_APPLICATION_ID);
$client = new \Vonage\Client($keypair);

$client->voice()->muteCall(UUID);
sleep(3);
$client->voice()->unmuteCall(UUID);

View full source

Run your code

Save this file to your machine and run it:

php index.php

Prerequisites

pip install vonage python-dotenv

Write the code

Add the following to mute-a-call.py:

from vonage import Auth, Vonage

client = Vonage(
    Auth(
        application_id=VONAGE_APPLICATION_ID,
        private_key=VONAGE_PRIVATE_KEY,
    )
)

client.voice.mute(VOICE_CALL_ID)
sleep(5)
client.voice.unmute(VOICE_CALL_ID)

View full source

Run your code

Save this file to your machine and run it:

python voice/mute-a-call.py

Prerequisites

gem install vonage

Write the code

Add the following to mute-a-call.rb:

client = Vonage::Client.new(
  application_id: VONAGE_APPLICATION_ID,
  private_key: VONAGE_PRIVATE_KEY
)

client.voice.mute(VOICE_CALL_ID)

sleep(5)

client.voice.unmute(VOICE_CALL_ID)

View full source

Run your code

Save this file to your machine and run it:

ruby mute-a-call.rb

Try it out

When you run the code the call is muted or unmuted depending on the action specified.

Further Reading

  • Conference Calling - This guide explains the two concepts Vonage associates with a call, a leg and a conversation.